<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Commanders: ButtonsCommanderButton Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Commanders
   </div>
   <div id="projectbrief">Arduino buttons/bus library</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('classButtonsCommanderButton.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="classButtonsCommanderButton-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">ButtonsCommanderButton Class Reference</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">

<p><code>#include &quot;<a class="el" href="ButtonsCommanderButton_8hpp_source.html">ButtonsCommanderButton.hpp</a>&quot;</code></p>
<div class="dynheader">
Inheritance diagram for ButtonsCommanderButton:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classButtonsCommanderButton.png" usemap="#ButtonsCommanderButton_map" alt=""/>
  <map id="ButtonsCommanderButton_map" name="ButtonsCommanderButton_map">
<area href="classButtonsCommanderAnalogPushes.html" alt="ButtonsCommanderAnalogPushes" shape="rect" coords="233,56,456,80"/>
<area href="classButtonsCommanderAnalogPushesItem.html" alt="ButtonsCommanderAnalogPushesItem" shape="rect" coords="233,112,456,136"/>
<area href="classButtonsCommanderEncoder.html" alt="ButtonsCommanderEncoder" shape="rect" coords="233,168,456,192"/>
<area href="classButtonsCommanderPotentiometer.html" alt="ButtonsCommanderPotentiometer" shape="rect" coords="233,224,456,248"/>
<area href="classButtonsCommanderPush.html" alt="ButtonsCommanderPush" shape="rect" coords="233,280,456,304"/>
<area href="classButtonsCommanderSwitch.html" alt="ButtonsCommanderSwitch" shape="rect" coords="233,336,456,360"/>
<area href="classButtonsCommanderSwitchOnePin.html" alt="ButtonsCommanderSwitchOnePin" shape="rect" coords="233,392,456,416"/>
<area href="classButtonsCommanderSwitchTwoPins.html" alt="ButtonsCommanderSwitchTwoPins" shape="rect" coords="233,448,456,472"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:afd8cb1a2b76510830062c5656bda0728"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderButton.html#afd8cb1a2b76510830062c5656bda0728">ButtonsCommanderButton</a> (unsigned long inId)</td></tr>
<tr class="separator:afd8cb1a2b76510830062c5656bda0728"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acbdd1d63fed7736c7358105428fbfd9c"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderButton.html#acbdd1d63fed7736c7358105428fbfd9c">GetId</a> () const </td></tr>
<tr class="separator:acbdd1d63fed7736c7358105428fbfd9c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1ab1295abfbfafef48d38a8795fb0be7"><td class="memItemLeft" align="right" valign="top">virtual ButtonsCommanderButton *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderButton.html#a1ab1295abfbfafef48d38a8795fb0be7">GetFromId</a> (unsigned long inId)</td></tr>
<tr class="separator:a1ab1295abfbfafef48d38a8795fb0be7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a823f11a7de3a5a01d0c076f7d5b4fae0"><td class="memItemLeft" align="right" valign="top">virtual int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderButton.html#a823f11a7de3a5a01d0c076f7d5b4fae0">GetPosition</a> () const </td></tr>
<tr class="separator:a823f11a7de3a5a01d0c076f7d5b4fae0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae1f260c75fbe475f674107bdc96f26cd"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderButton.html#ae1f260c75fbe475f674107bdc96f26cd">beforeFirstLoop</a> ()</td></tr>
<tr class="separator:ae1f260c75fbe475f674107bdc96f26cd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a44bbb289ce1f64b42a88126e8dd42f7e"><td class="memItemLeft" align="right" valign="top">virtual unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderButton.html#a44bbb289ce1f64b42a88126e8dd42f7e">loop</a> ()</td></tr>
<tr class="separator:a44bbb289ce1f64b42a88126e8dd42f7e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a270eade0db966b7e72b6dc5462377593"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderButton.html#a270eade0db966b7e72b6dc5462377593">EndLoop</a> ()</td></tr>
<tr class="separator:a270eade0db966b7e72b6dc5462377593"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7fa0ef8aede172936672b384f81b03bb"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderButton.html#a7fa0ef8aede172936672b384f81b03bb">SetNextButton</a> (ButtonsCommanderButton *inpButton)</td></tr>
<tr class="separator:a7fa0ef8aede172936672b384f81b03bb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0dac1c9fcdc5bbe1d2b00a38192f555c"><td class="memItemLeft" align="right" valign="top">ButtonsCommanderButton *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderButton.html#a0dac1c9fcdc5bbe1d2b00a38192f555c">GetNextButton</a> () const </td></tr>
<tr class="separator:a0dac1c9fcdc5bbe1d2b00a38192f555c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a3b40667770ab04694a2ea85f11aebfe0"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderButton.html#a3b40667770ab04694a2ea85f11aebfe0">Id</a></td></tr>
<tr class="separator:a3b40667770ab04694a2ea85f11aebfe0"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>A button is a hardware device allowing user to act when this device is used. Its id is sent, and the listener of the commander events can do the job.</p>
<p>This is the base class for all buttons, this class should not be instanciate ! </p>

<p class="definition">Definition at line <a class="el" href="ButtonsCommanderButton_8hpp_source.html#l00015">15</a> of file <a class="el" href="ButtonsCommanderButton_8hpp_source.html">ButtonsCommanderButton.hpp</a>.</p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="afd8cb1a2b76510830062c5656bda0728"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">ButtonsCommanderButton::ButtonsCommanderButton </td>
          <td>(</td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>inId</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Default constructor. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">inId</td><td>each button can be identified by at least one id. </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="ButtonsCommanderButton_8cpp_source.html#l00010">10</a> of file <a class="el" href="ButtonsCommanderButton_8cpp_source.html">ButtonsCommanderButton.cpp</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="ae1f260c75fbe475f674107bdc96f26cd"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void ButtonsCommanderButton::beforeFirstLoop </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>This function will be called after sketch Setup(), but before the first call to <a class="el" href="classButtonsCommanderButton.html#a44bbb289ce1f64b42a88126e8dd42f7e">loop()</a>. It will be called only one time. </p>

<p>Reimplemented in <a class="el" href="classButtonsCommanderSwitch.html#ac5acada95c180aa8011e8b4c4ba3e6ce">ButtonsCommanderSwitch</a>, <a class="el" href="classButtonsCommanderSwitchTwoPins.html#a09bec828df1adbfe561730b1a443e72e">ButtonsCommanderSwitchTwoPins</a>, and <a class="el" href="classButtonsCommanderSwitchOnePin.html#af4a18cad9ddbb3f59ebe3e83e446a377">ButtonsCommanderSwitchOnePin</a>.</p>

<p class="definition">Definition at line <a class="el" href="ButtonsCommanderButton_8hpp_source.html#l00044">44</a> of file <a class="el" href="ButtonsCommanderButton_8hpp_source.html">ButtonsCommanderButton.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a270eade0db966b7e72b6dc5462377593"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void ButtonsCommanderButton::EndLoop </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Reinitialize the button for future use. Called at the end of the loop, if an event has been raised. </p>

<p>Reimplemented in <a class="el" href="classButtonsCommanderAnalogPushes.html#aed6eacfc1656e7aacd24cf3ab6565ea1">ButtonsCommanderAnalogPushes</a>.</p>

<p class="definition">Definition at line <a class="el" href="ButtonsCommanderButton_8hpp_source.html#l00053">53</a> of file <a class="el" href="ButtonsCommanderButton_8hpp_source.html">ButtonsCommanderButton.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a1ab1295abfbfafef48d38a8795fb0be7"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual ButtonsCommanderButton* ButtonsCommanderButton::GetFromId </td>
          <td>(</td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>inId</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Gets the button's address from its id. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">inId</td><td>id to find. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>found button address or NULL if not found. </dd></dl>

<p>Reimplemented in <a class="el" href="classButtonsCommanderAnalogPushes.html#ae976e740dfe282cf22e107cfa6b13dc3">ButtonsCommanderAnalogPushes</a>.</p>

<p class="definition">Definition at line <a class="el" href="ButtonsCommanderButton_8hpp_source.html#l00035">35</a> of file <a class="el" href="ButtonsCommanderButton_8hpp_source.html">ButtonsCommanderButton.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="acbdd1d63fed7736c7358105428fbfd9c"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long ButtonsCommanderButton::GetId </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Gets the button's id. </p>

<p class="definition">Definition at line <a class="el" href="ButtonsCommanderButton_8hpp_source.html#l00030">30</a> of file <a class="el" href="ButtonsCommanderButton_8hpp_source.html">ButtonsCommanderButton.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a0dac1c9fcdc5bbe1d2b00a38192f555c"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">ButtonsCommanderButton* ButtonsCommanderButton::GetNextButton </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Gets the next button of 'this' in the linked list. </p><dl class="section return"><dt>Returns</dt><dd>address of the next button, or NULL if this was the end of the list. </dd></dl>

<p class="definition">Definition at line <a class="el" href="ButtonsCommanderButton_8hpp_source.html#l00062">62</a> of file <a class="el" href="ButtonsCommanderButton_8hpp_source.html">ButtonsCommanderButton.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a823f11a7de3a5a01d0c076f7d5b4fae0"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual int ButtonsCommanderButton::GetPosition </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Gets the current position of the button. Only possible on analog buttons like potentiometers or encoders. </p><dl class="section return"><dt>Returns</dt><dd>Current value, or 0 if the button does not allow this. </dd></dl>

<p>Reimplemented in <a class="el" href="classButtonsCommanderEncoder.html#af9cc403a8374e4d9493648b3cfb8c869">ButtonsCommanderEncoder</a>, and <a class="el" href="classButtonsCommanderPotentiometer.html#a2c1d733902d73d9c57be2c408fc5bc77">ButtonsCommanderPotentiometer</a>.</p>

<p class="definition">Definition at line <a class="el" href="ButtonsCommanderButton_8hpp_source.html#l00040">40</a> of file <a class="el" href="ButtonsCommanderButton_8hpp_source.html">ButtonsCommanderButton.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a44bbb289ce1f64b42a88126e8dd42f7e"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual unsigned long ButtonsCommanderButton::loop </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Main loop function. </p>

<p>Reimplemented in <a class="el" href="classButtonsCommanderAnalogPushes.html#ab72557e2f070f17498f5e43f82ec52f3">ButtonsCommanderAnalogPushes</a>, <a class="el" href="classButtonsCommanderEncoder.html#a7fa7dfee89534eaa194aa578d53427a9">ButtonsCommanderEncoder</a>, <a class="el" href="classButtonsCommanderPush.html#a7b1af7744bd5bafaf42e355cb5a0a7dd">ButtonsCommanderPush</a>, <a class="el" href="classButtonsCommanderSwitch.html#a3e66f87ce692b0524bf9940dec663d21">ButtonsCommanderSwitch</a>, <a class="el" href="classButtonsCommanderSwitchTwoPins.html#a096c4bc62bdc8144a6fe68808726bc73">ButtonsCommanderSwitchTwoPins</a>, <a class="el" href="classButtonsCommanderPotentiometer.html#a64f51252b6a09664897197989ec87a08">ButtonsCommanderPotentiometer</a>, and <a class="el" href="classButtonsCommanderSwitchOnePin.html#a13b39217d1b55574422ea1d8bded0f62">ButtonsCommanderSwitchOnePin</a>.</p>

<p class="definition">Definition at line <a class="el" href="ButtonsCommanderButton_8hpp_source.html#l00046">46</a> of file <a class="el" href="ButtonsCommanderButton_8hpp_source.html">ButtonsCommanderButton.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a7fa0ef8aede172936672b384f81b03bb"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void ButtonsCommanderButton::SetNextButton </td>
          <td>(</td>
          <td class="paramtype">ButtonsCommanderButton *&#160;</td>
          <td class="paramname"><em>inpButton</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Adds a new button at the end of the button linked list. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">inpButton</td><td>new button to add. </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="ButtonsCommanderButton_8hpp_source.html#l00058">58</a> of file <a class="el" href="ButtonsCommanderButton_8hpp_source.html">ButtonsCommanderButton.hpp</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a class="anchor" id="a3b40667770ab04694a2ea85f11aebfe0"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long ButtonsCommanderButton::Id</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p><a class="el" href="classButtonsCommanderButton.html#a3b40667770ab04694a2ea85f11aebfe0">Id</a> of this button. This id should be unique ! </p>

<p class="definition">Definition at line <a class="el" href="ButtonsCommanderButton_8hpp_source.html#l00019">19</a> of file <a class="el" href="ButtonsCommanderButton_8hpp_source.html">ButtonsCommanderButton.hpp</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>D:/Mes documents/Trusty/Arduino/Libraries/Commanders/src/<a class="el" href="ButtonsCommanderButton_8hpp_source.html">ButtonsCommanderButton.hpp</a></li>
<li>D:/Mes documents/Trusty/Arduino/Libraries/Commanders/src/<a class="el" href="ButtonsCommanderButton_8cpp_source.html">ButtonsCommanderButton.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="classButtonsCommanderButton.html">ButtonsCommanderButton</a></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:55:02 for Commanders &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
